
-- =============================================
-- Author:		Daniel R. Harris and Darren W. Henderson
-- Create date: 9/20/15
-- Description:	Initialize tableau job
-- =============================================
CREATE PROCEDURE [dbo].[init_tableau_job] 
	-- Add the parameters for the stored procedure here
	@TABLEAU_REQUEST_ID int = 0
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

DECLARE @USER VARCHAR(50) = '';
DECLARE @QNAME VARCHAR(100) = '';
DECLARE @QMID INT = '';
DECLARE @SQL NVARCHAR(MAX) = '';

SELECT @USER=TER.USER_ID, @SQL=TER.GENERATED_SQL, @QNAME=TER.QUERY_NAME,
	@QMID=TER.QUERY_MASTER_ID
FROM TABLEAU_EXTRACT_REQUEST TER
WHERE ID = @TABLEAU_REQUEST_ID;

IF OBJECT_ID('#TEMPDB..#TEMP_TDE_PATNT') <> 0 DROP TABLE #TEMP_TDE_PATNT;
CREATE TABLE #TEMP_TDE_PATNT ( PATIENT_NUM INT );

INSERT INTO #TEMP_TDE_PATNT ( PATIENT_NUM ) 
EXEC sp_executesql @SQL;

--UPDATE #TEMP_TDE_PATNT SET TDE_ID = @TABLEAU_REQUEST_ID; 

INSERT INTO I2B2_TDE.dbo.TABLEAU_PATNT_SET ( TABLEAU_EXTRACT_ID, PATIENT_NUM ) 
SELECT @TABLEAU_REQUEST_ID, PATIENT_NUM 
FROM #TEMP_TDE_PATNT;

DROP TABLE #TEMP_TDE_PATNT;

DECLARE @VSQL NVARCHAR(MAX) = '';

SELECT @VSQL = SQL_TXT
FROM [TDE_DEV].[SQL_QUERIES]
WHERE DIMENSION_NAME = 'PATIENT_ENCOUNTER'

SET @VSQL = REPLACE( @VSQL, '<USER_ID>', @USER );
SET @VSQL = REPLACE( @VSQL, '<QMID>', @QMID );
SET @VSQL = REPLACE( @VSQL, '<TER_ID>', @TABLEAU_REQUEST_ID );
SET @VSQL = REPLACE( @VSQL, '<INSERT TABLEAU_REQUEST_ID>', @TABLEAU_REQUEST_ID );

EXEC sp_executesql @VSQL;
INSERT INTO TDE_DEV.PATNT_ENCNTR VALUES (@TABLEAU_REQUEST_ID, 'select * from TDE.' + @USER + '_' + ltrim(rtrim(cast(@QMID as CHAR))) + '_' + ltrim(rtrim(cast(@TABLEAU_REQUEST_ID as CHAR))) + '_PATNT_ENCNTR_DTL')


SELECT @VSQL = SQL_TXT
FROM [TDE_DEV].[SQL_QUERIES]
WHERE DIMENSION_NAME = 'PATIENT_DX'

SET @VSQL = REPLACE( @VSQL, '<USER_ID>', @USER );
SET @VSQL = REPLACE( @VSQL, '<QMID>', @QMID );
SET @VSQL = REPLACE( @VSQL, '<TER_ID>', @TABLEAU_REQUEST_ID );
SET @VSQL = REPLACE( @VSQL, '<INSERT TABLEAU_REQUEST_ID>', @TABLEAU_REQUEST_ID );
INSERT INTO TDE_DEV.PATNT_ENCNTR_DX VALUES (@TABLEAU_REQUEST_ID, @VSQL);
--EXEC sp_executesql @VSQL;

SELECT @VSQL = SQL_TXT
FROM [TDE_DEV].[SQL_QUERIES]
WHERE DIMENSION_NAME = 'PATIENT_PROC'

SET @VSQL = REPLACE( @VSQL, '<USER_ID>', @USER );
SET @VSQL = REPLACE( @VSQL, '<QMID>', @QMID );
SET @VSQL = REPLACE( @VSQL, '<TER_ID>', @TABLEAU_REQUEST_ID );
SET @VSQL = REPLACE( @VSQL, '<INSERT TABLEAU_REQUEST_ID>', @TABLEAU_REQUEST_ID );
INSERT INTO TDE_DEV.PATNT_ENCNTR_PROC VALUES  (@TABLEAU_REQUEST_ID, @VSQL);
--EXEC sp_executesql @VSQL;

SELECT @VSQL = SQL_TXT
FROM [TDE_DEV].[SQL_QUERIES]
WHERE DIMENSION_NAME = 'PATIENT_LABS'

SET @VSQL = REPLACE( @VSQL, '<USER_ID>', @USER );
SET @VSQL = REPLACE( @VSQL, '<QMID>', @QMID );
SET @VSQL = REPLACE( @VSQL, '<TER_ID>', @TABLEAU_REQUEST_ID );
SET @VSQL = REPLACE( @VSQL, '<INSERT TABLEAU_REQUEST_ID>', @TABLEAU_REQUEST_ID );
INSERT INTO TDE_DEV.PATNT_ENCNTR_LABS VALUES (@TABLEAU_REQUEST_ID, @VSQL);
--EXEC sp_executesql @VSQL;

SELECT @VSQL = SQL_TXT
FROM [TDE_DEV].[SQL_QUERIES]
WHERE DIMENSION_NAME = 'PATIENT_MEDS'

SET @VSQL = REPLACE( @VSQL, '<USER_ID>', @USER );
SET @VSQL = REPLACE( @VSQL, '<QMID>', @QMID );
SET @VSQL = REPLACE( @VSQL, '<TER_ID>', @TABLEAU_REQUEST_ID );
SET @VSQL = REPLACE( @VSQL, '<INSERT TABLEAU_REQUEST_ID>', @TABLEAU_REQUEST_ID );
INSERT INTO TDE_DEV.PATNT_ENCNTR_MEDS VALUES (@TABLEAU_REQUEST_ID, @VSQL);
--EXEC sp_executesql @VSQL;

END

